function  [PMat AMat BMat CMat MMat M  h WMat XMat OMat GamMat YMat FiMat PsiMat]= matrices(T,G,A,intL,exL,impL,L,FrA,ToA,Losses,m,k,n,NyNum)
%A function that creates all the matrices needed to create the primal and
%dual versions of the hydrothermal generation planning problem

%create the AMatrisene
AMat=cell(T,T);
for t=1:T
    for s=1:T
        AMat{t,s}=zeros(m(t),n); 
                                 
    end
end

%Lager frst matrisene for s=t (alts innevrende periode.) Trenger tre
%sub-matriser; ALin, Afyll1 og Afyll2 pga strukturen p {Att}-matrisene
ALin=zeros(A,L); %denne matrisen er for borderflowvariablene i demandconstrainten.
for i = 1:A
    for l=1:L
        if(ToA(l)==i)
            ALin(i,l)=1-Losses;
        elseif(FrA(l)==i)
            ALin(i,l)=-1;
        end
    end
end

Afyll1=eye(A);
Afyll2=1*eye(A*G+L);

for t=1:T   
    AMat{t,t}(1:A,G*A+1:n)=ALin;                %demandconstraints lines
    AMat{t,t}(10+1:10+G*A+L,1:n)=-Afyll2;       %maxcapacity
    AMat{t,t}(10+G*A+L+1:m(1),1:n)=Afyll2;      %nonnegativity
    for g=1:A:(A*G-A+1) 
        AMat{t,t}(1:A,g:g+A-1)=Afyll1;          %demandconstraints generatorer
    end
end

%fyller s inn matrisene for s<t. dersom s>t er matrisene bare null. Vi
%bruker fortsatt Afyll1-matrisen..

for t=1:T
    for s=1:(t-1)
        AMat{t,s}(A+1:7,1:3)=eye(3);
        AMat{t,s}(8:10,1:3)=-1*eye(3);
    end
end

%fylle ut de nederste radene for amatrisene i siste periode
for s=1:T
    AMat{T,s}(m(1)+1:m(1)+3,1:3)=eye(3);
    AMat{T,s}(m(1)+1+3:m(T),1:3)=-1*eye(3);
end

%lager B-matrisene

BMat = cell(T,1);

for t=1:T
   BMat{t}=sym('b', [m(t) k(t)]);
   BMat{t}(1:m(t),2:k(t))=zeros(m(t),k(t)); %fyller med nuller
   BMat{t}(A+6+G*A+L+1:m(1),1)=0; %non-neg constraints
   for i=1:A
       
        BMat{t}(i,1)=['Demand(' num2str(t) ',' num2str(i) ')' ];
   
        for g= 1:G
            BMat{t}(6+g*A+i,1)=['-GC(' num2str(g) ',' num2str(i) ')'];
        end
        
 
   end
   
   for l = 1:L
       BMat{t}(10+G*A+l,1)=['-TC(' num2str(l) ')'];
   end
   
   for i=1:3 %resconstraints
        if t >1
            BMat{t}(A+i,1)=['Ma(' num2str(i) ')' ];
            BMat{t}(A+3+i,1)=['Mi(' num2str(i) ')' ];
        else
            BMat{t}(A+i,1)=0;
            BMat{t}(A+3+i,1)=0;  
        end
        
        %N m vi fylle ut resten av B-matrisen med 1 og -1     

        
        if (t==T)%alts den lange B-matrisen som gr til m(1)+2*A
            BMat{T}(m(1)+i,1)=['MaEnd(' num2str(i) ') +vstar(' num2str(t) ',' num2str(i) ')'];
            BMat{T}(m(1)+i+3,1)=['MiEnd(' num2str(i) ')-vstar(' num2str(t) ',' num2str(i) ')'];

        end  
   end
   
   for teller =2:NyNum:k(t)    %f.eks 2 8 14 (alt som har med tilsig i area 1) 
       BMat{T}(m(1)+1:m(1)+3,teller:teller+2)=eye(3);
       BMat{T}(m(1)+4:m(1)+6,teller:teller+2)=-eye(3);
   end
   
   for teller =2:NyNum:k(t)    %f.eks 2 8 14 (alt som har med tilsig i area 1)
        BMat{t}(5:7,teller:teller+2)=eye(3);
        BMat{t}(8:10,teller:teller+2)=-eye(3);
   end  
   
end

%PMatrisene PMat{t}(k^t,k) k^T er det samme som single=k 
PMat=cell(T,1);
for i=1:T
PMat{i}=eye(k(i),k(T));
end

%lager CMatrisene

CMat=cell(T,1);

%CMat{1}=sym('c', [n k(1)]);
 for t=1:T
    CMat{t} = sym('c', [n k(t)]);
    %fyller inn med nuller
    CMat{t}(:,2:k(t))=0;
    %borderflow
    for l=1:L
        if (l<=intL) %interne linjer innebrer ingen kost
            CMat{t}(G*A+l,1)=0;
        elseif (l>intL & l<=intL+exL) %export (da kan man tjene penger!)
            CMat{t}(G*A+l,1)=['-PP(' num2str(t) ',' num2str(ToA(l)) ')'];
        else %import
            CMat{t}(G*A+l,1)=['PP(' num2str(t) ',' num2str(FrA(l)) ')'];
        end
    end
 end

%expected for t=1
%Hydro cost
CMat{1}(1:A,1)=['VC(' num2str(1) ')'];
%nuclear cost        
CMat{1}(A+1:2*A,1)=['VC(' num2str(2) ')'];
%kull
for g=3:4 
    CMat{1}((g-1)*A+1:g*A,1)=  ['PKstar(1)/(EnCon(' num2str(g) ')*Eff(' num2str(g) '))+VC(' num2str(g) ')+PCstar(1)*CarCon(' num2str(g) ')/Eff(' num2str(g) ')'];    
end
%gas
for g=5:7
    CMat{1}((g-1)*A+1:g*A,1)=['PGstar(1)/(EnCon(' num2str(g) ')*Eff(' num2str(g) '))+VC(' num2str(g) ')+PCstar(1)*CarCon(' num2str(g) ')/Eff(' num2str(g) ')'];
end

for t=2:T
    for g=1:G %variable cost
        CMat{t}((g-1)*A+1:g*A,1)=['VC(' num2str(g) ')'];    
    end
    for g=3:G %dvs de med carbon. k(t) elementet er det som har med PC  gjre   
        CMat{t}((g-1)*A+1:g*A,k(t))=['CarCon(' num2str(g) ')/Eff(' num2str(g) ')']; 
        if g<5 %dvs kull
            CMat{t}((g-1)*A+1:g*A,(k(t)-2))=['1/(EnCon(' num2str(g) ')*Eff(' num2str(g) '))'];
        else %dvs gass
            CMat{t}((g-1)*A+1:g*A,(k(t)-1))=['1/(EnCon(' num2str(g) ')*Eff(' num2str(g) '))'];
        end
    end   
end


%Lager xi og Mmatrisen
xistar =sym('xi',[k(T),1]);
xistar(1)=1;
%vstar(t,a)
%
teller=1;
for i=2:NyNum:k(T)

    for j=1:3
        xistar(i+j-1)=['vstar(' num2str(teller) ','  num2str(j) ')'];
    end

xistar(i+3)=['PKstar(' num2str(teller+1) ')'];
xistar(i+3+1)=['PGstar(' num2str(teller+1) ')'];
xistar(i+3+2)=['PCstar(' num2str(teller+1) ')'];
  teller=teller+1;  
end


M=sym('m',[k(T) k(T)]);
M=xistar*(xistar.');

for i=2:NyNum:k(T)-NyNum+1
    for j=1:3
   
    M(i+j-1,i+j-1)=M(i+j-1,i+j-1)+ strcat('varv(', num2str(1+(i-2)/NyNum), ',', num2str(j), ')');%6 er fordi det er antall usikreparametre avdekket i hver periode!
    %M(i+j-1,i+j-1)=M_temp(i+j-1,i+j-1)+'varv('+ num2str(1+(i-2)/NyNum);
    end
    
   M(i+j,i+j) = M(i+j,i+j) + strcat('varPK(', num2str(2+(i-2)/NyNum) , ')' );
   M(i+j+1,i+j+1) = M(i+j+1,i+j+1) +strcat('varPG(' , num2str(2+(i-2)/NyNum) , ')' );
   M(i+j+2,i+j+2) = M(i+j+2,i+j+2) +strcat('varPC(' , num2str(2+(i-2)/NyNum) , ')' ); 
end


%lager MMat{t}
MMat=cell(T,1);

for t=1:T
MMat{t} = sym('m', [k(T) k(t)]);
    
MMat{t}((k(t)+1):k(T),1)=xistar((k(t)+1):k(T));%her fr den ting fra xi
MMat{t}(1:k(t),1:k(t))=eye(k(t),k(t));%her fr vi inn enerene
MMat{t}(k(t)+1:k(T),2:k(t))=0;%her legger vi inn de nullene vi mangler
end



%Lager W-Matrisen. Her brukes xistar-vektoren!!

WMat = sym('W', [2*k(T) k(T)]);
tiden=1;
for i = 3:2*NyNum:2*k(T)-NyNum

    teller=-1;
    for j=1:3
    
        
        %WMat(i+j+teller,1)=strcat('(Thetav(', num2str(tiden) ,',', num2str(j) , ')-1)*vstar(' , num2str(tiden) ,',' , num2str(j), ')');
        
        WMat(i+j+teller,1)=['(Thetav(' num2str(tiden) ',' num2str(j)  ')-1)*vstar('  num2str(tiden) ','  num2str(j) ')'];
        WMat(i+j+teller+1,1)=['(Thetav(' num2str(tiden) ',' num2str(j)  ')+1)*vstar('  num2str(tiden) ','  num2str(j) ')'];
        
        teller=teller+1;
    end
    %husk at du m ha to av hver!
    WMat(i+j+teller+1,1)=['(ThetaPK(' num2str(tiden+1)   ')-1)*PKstar('  num2str(tiden+1)   ')'];
    WMat(i+j+teller+2,1)=['(ThetaPK(' num2str(tiden+1)   ')+1)*PKstar('  num2str(tiden+1)    ')'];
    
    WMat(i+j+teller+3,1)=['(ThetaPG(' num2str(tiden+1) ')-1)*PGstar('  num2str(tiden+1)    ')'];
    WMat(i+j+teller+4,1)=['(ThetaPG(' num2str(tiden+1) ')+1)*PGstar('  num2str(tiden+1)   ')'];
    
    WMat(i+j+teller+5,1)=['(ThetaPC(' num2str(tiden+1) ')-1)*PCstar('  num2str(tiden+1)    ')'];
    WMat(i+j+teller+6,1)=['(ThetaPC(' num2str(tiden+1) ')+1)*PCstar('  num2str(tiden+1)   ')'];
 
    tiden=tiden+1;  
end


%fyller med nuller:
WMat(1:2*k(T) , 2:k(T)) = 0;
%fyller med 1 og -1
for i = 2:2:2*k(T)
    for j=1:k(T)
        if j==i/2
        WMat(i-1,j)=1;
        WMat(i,j)=-1;
        end
    end
end 



Lager h-vektoren

h=zeros(2*k(T),1);
h(1)=1;
h(2)=-1;




%Lager variable-matriser til primalen  
%XMatrisene XMat{t}(g,k^t)
XMat=cell(T,1);

for t=1:T
    XMat{t} = sym('pi', [n k(t)]);
    for i =1:n %disse lkkene er for  f elementene til riktig format til mosel!
       for j = 1:k(t)
            XMat{t}(i,j)= ['pii(' num2str(t) ',' num2str(i) ',' num2str(j) ')'];
       end
    end
end

%Lager OMat
OMat=cell(T,1);
for t =1:T
    OMat{t} = sym('o', [m(t) 2*k(T)]);
    for i =1:m(t) %disse lkkene er for  f elementene til riktig format til mosel!
       for j = 1:2*k(T)
            OMat{t}(i,j)= ['o(' num2str(t) ',' num2str(i) ',' num2str(j) ')'];
       end
    end
end
%}

%Lager GamMat
GamMat=cell(T,1);
for t =1:T
    GamMat{t} = sym('gam', [n 2*k(T)]);
    for i =1:n %disse lkkene er for  f elementene til riktig format til mosel!
       for j = 1:2*k(T)
            GamMat{t}(i,j)= ['gam(' num2str(t) ',' num2str(i) ',' num2str(j) ')'];
       end
    end
    
end 

%Lager variable-matriser til dualalen
%Lager y-mat
YMat=cell(T,1);

for t=1:T
    YMat{t} = sym('y', [m(t) k(t)]);
    for i =1:m(t) %disse lkkene er for  f elementene til riktig format til mosel!
       for j = 1:k(t)
            YMat{t}(i,j)= ['y(' num2str(t) ',' num2str(i) ',' num2str(j) ')'];
       end
    end
end

%Lager fi-mat
FiMat=cell(T,1);

for t=1:T
    FiMat{t} = sym('fi', [n 2*k(T)]);
    for i =1:n %disse lkkene er for  f elementene til riktig format til mosel!
       for j = 1:2*k(T)
            FiMat{t}(i,j)= ['fi(' num2str(t) ',' num2str(i) ',' num2str(j) ')'];
       end
    end
end

%Lager psi-mat
PsiMat=cell(T,1);

for t=1:T
    PsiMat{t} = sym('ps', [m(t) 2*k(T)]); 
    for i =1:m(t) %disse lkkene er for  f elementene til riktig format til mosel! (mtte kalle matrisen ps siden psi er noe annet)
       for j = 1:2*k(T)
            PsiMat{t}(i,j)= ['ps(' num2str(t) ',' num2str(i) ',' num2str(j) ')'];
       end
    end
end


%

end



























